Main Page Widgets Namespaces Book

# Gtk::TreeModel Class Reference
[TreeView Classes]

Inheritance diagram for Gtk::TreeModel:

[legend]
List of all members.

## Detailed Description

This class defines a generic tree interface for use by the Gtk::TreeView widget.

It is is designed to be usable with any appropriate data structure. The programmer just has to implement this interface on their own data type for it to be viewable by a Gtk::TreeView widget.

The model is represented as a hierarchical tree of strongly-typed, columned data. In other words, the model can be seen as a tree where every node has different values depending on which column is being queried. The type of data found in a column is determined by TreeModel::Column<> templates. The types are homogeneous per column across all nodes. It is important to note that this interface only provides a way of examining a model and observing changes. The implementation of each individual model decides how and if changes are made.

In order to make life simpler for programmers who do not need to write their own specialized model, two generic models are provided - the Gtk::TreeStore and the Gtk::ListStore. To use these, the developer simply pushes data into these models as necessary. These models provide the data structure as well as all appropriate tree interfaces. As a result, implementing drag and drop, sorting, and storing data is trivial. For the vast majority of trees and lists, these two models are sufficient.

Models are accessed on a node/column level of granularity. One can query for the value of a model at a certain node and a certain column on that node. There are two structures used to reference a particular node in a model. They are the Path and the iterator. Most of the interface consists of operations on a iterator.

A path is essentially a potential node. It is a location on a model that may or may not actually correspond to a node on a specific model. A Path can be converted into either an array of unsigned integers or a string. The string form is a list of numbers separated by a colon. Each number refers to the offset at that level. Thus, the path "0" refers to the root node and the path "2:4" refers to the fifth child of the third node.

By contrast, a iterator is a reference to a specific node on a specific model. It is a generic structure with an integer and three generic pointers. These are filled in by the model in a model-specific way. One can convert a path to an iterator by calling Gtk::TreeModel::get_iter(). These iterators are the primary way of accessing a model and are similar to the iterators used by Gtk::TextBuffer. The model interface defines a set of operations using them for navigating the model.

The lifecycle of an iterator can be a little confusing at first. Iterators are expected to always be valid for as long as the model is unchanged (and doesn't emit a signal). The model is considered to own all outstanding iterators and nothing needs to be done to free them from the user's point of view. Additionally, some models guarantee that an iterator is valid for as long as the node it refers to is valid (most notably the Gtk::TreeStore and Gtk::ListStore). Although generally uninteresting, as one always has to allow for the case where iterators do not persist beyond a signal, some very important performance enhancements were made in the sort model. As a result, the GTK_TREE_MODEL_ITERS_PERSIST flag was added to indicate this behavior.

## Public Types

typedef TreeModelColumnRecord | ColumnRecord
typedef TreeIter | iterator
typedef const TreeIter | const_iterator
typedef TreeRow | Row
typedef TreePath | Path
typedef TreeRowReference | RowReference
typedef TreeNodeChildren | Children
typedef SigC::Slot1< bool, const TreeModel::iterator& > | SlotForeachIter
typedef SigC::Slot1< bool, const TreeModel::Path& > | SlotForeachPath
typedef SigC::Slot2< bool, const TreeModel::Path&, const TreeModel::iterator& > | SlotForeachPathAndIter

## Public Member Functions

virtual | ~TreeModel ()
GtkTreeModel* | gobj ()
| Provides access to the underlying C GObject.
const GtkTreeModel* | gobj () const
| Provides access to the underlying C GObject.
iterator | get_iter (const Path& path)
iterator | get_iter (const Glib::ustring& path_string)
Children | children ()
| This returns an STL-like container API, for iterating over the rows.
void | foreach (const SlotForeachIter& slot)
void | foreach (const SlotForeachPath& slot)
void | foreach (const SlotForeachPathAndIter& slot)
TreeModelFlags | get_flags () const
| Returns a set of flags supported by this interface.
int | get_n_columns () const
| Returns the number of columns supported by tree_model .
GType | get_column_type (int index) const
| Returns the type of the column.
TreeModel::Path | get_path (const iterator& iter) const
| Returns a Gtk::TreePath referenced by iter .
void | row_changed (const Path& path, const iterator& iter)
| Emits the "row_changed" signal on tree_model .
void | row_inserted (const Path& path, const iterator& iter)
| Emits the "row_inserted" signal on tree_model.
void | row_has_child_toggled (const Path& path, const iterator& iter)
| Emits the "row_has_child_toggled" signal on tree_model .
void | row_deleted (const Path& path)
| Emits the "row_deleted" signal on tree_model .
void | rows_reordered (const Path& path, const iterator& iter, int* new_order)
| Emits the "rows_reordered" signal on tree_model .
Glib::ustring | get_string (const iterator& iter) const
| Generates a string representation of the iter.
Glib::SignalProxy2< void, const TreeModel::Path&, const TreeModel::iterator& > | signal_row_changed ()
Glib::SignalProxy2< void, const TreeModel::Path&, const TreeModel::iterator& > | signal_row_inserted ()
Glib::SignalProxy2< void, const TreeModel::Path&, const TreeModel::iterator& > | signal_row_has_child_toggled ()
Glib::SignalProxy1< void, const TreeModel::Path& > | signal_row_deleted ()
Glib::SignalProxy3< void, const TreeModel::Path&, const TreeModel::iterator&, int* > | signal_rows_reordered ()

## Static Public Member Functions

void | add_interface (GType gtype_implementer)

## Protected Member Functions

virtual void | set_value_impl (const iterator& row, int column, const Glib::ValueBase& value)
virtual void | get_value_impl (const iterator& row, int column, Glib::ValueBase& value) const
virtual TreeModelFlags | get_flags_vfunc ()
virtual int | get_n_columns_vfunc ()
virtual GType | get_column_type_vfunc (int index)
virtual bool | iter_next_vfunc (GtkTreeIter* iter)
virtual bool | iter_children_vfunc (GtkTreeIter* iter, const GtkTreeIter* parent)
virtual bool | iter_has_child_vfunc (const GtkTreeIter* iter)
virtual int | iter_n_children_vfunc (const GtkTreeIter* iter)
virtual bool | iter_nth_child_vfunc (GtkTreeIter* iter, const GtkTreeIter* parent, int n)
virtual bool | iter_parent_vfunc (GtkTreeIter* iter, const GtkTreeIter* child)
virtual void | ref_node_vfunc (GtkTreeIter* iter)
virtual void | unref_node_vfunc (GtkTreeIter* iter)
virtual TreeModel::Path | get_path_vfunc (const TreeModel::iterator& iter)
virtual bool | get_iter_vfunc (GtkTreeIter* iter, const TreeModel::Path& path)
virtual void | get_value_vfunc (const TreeModel::iterator& iter, int column, GValue* value)
virtual void | on_row_changed (const TreeModel::Path& path, const TreeModel::iterator& iter)
virtual void | on_row_inserted (const TreeModel::Path& path, const TreeModel::iterator& iter)
virtual void | on_row_has_child_toggled (const TreeModel::Path& path, const TreeModel::iterator& iter)
virtual void | on_row_deleted (const TreeModel::Path& path)
virtual void | on_rows_reordered (const TreeModel::Path& path, const TreeModel::iterator& iter, int* new_order)

## Friends

class | Gtk::TreeModelSort
class | Gtk::TreeRow

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gtk::TreeModel> | wrap (GtkTreeModel* object, bool take_copy=false)

## Member Typedef Documentation

typedef TreeNodeChildren Gtk::TreeModel::Children

typedef TreeModelColumnRecord Gtk::TreeModel::ColumnRecord

typedef const TreeIter Gtk::TreeModel::const_iterator

typedef TreeIter Gtk::TreeModel::iterator

typedef TreePath Gtk::TreeModel::Path

typedef TreeRow Gtk::TreeModel::Row

typedef TreeRowReference Gtk::TreeModel::RowReference

typedef SigC::Slot1<bool, const TreeModel::iterator&> Gtk::TreeModel::SlotForeachIter

typedef SigC::Slot1<bool, const TreeModel::Path&> Gtk::TreeModel::SlotForeachPath

typedef SigC::Slot2<bool, const TreeModel::Path&, const TreeModel::iterator&> Gtk::TreeModel::SlotForeachPathAndIter

## Constructor & Destructor Documentation

virtual Gtk::TreeModel::~TreeModel | ( |  | ) | `[virtual]`

## Member Function Documentation

void Gtk::TreeModel::add_interface | ( | GType | gtype_implementer | ) | `[static]`

Children Gtk::TreeModel::children | ( |  | ) |

| This returns an STL-like container API, for iterating over the rows.

void Gtk::TreeModel::foreach | ( | const SlotForeachPathAndIter& | slot | ) |

void Gtk::TreeModel::foreach | ( | const SlotForeachPath& | slot | ) |

void Gtk::TreeModel::foreach | ( | const SlotForeachIter& | slot | ) |

GType Gtk::TreeModel::get_column_type | ( | int | index | ) | const

Returns the type of the column.

Parameters:

  index_ | The column index.

Returns:
  The type of the column.

virtual GType Gtk::TreeModel::get_column_type_vfunc | ( | int | index | ) | `[protected, virtual]`

TreeModelFlags Gtk::TreeModel::get_flags | ( |  | ) | const

Returns a set of flags supported by this interface.

The flags are a bitwise combination of Gtk::TreeModelFlags. The flags supported should not change during the lifecycle of the tree_model.

Returns:
  The flags supported by this interface.

virtual TreeModelFlags Gtk::TreeModel::get_flags_vfunc | ( |  | ) | `[protected, virtual]`

iterator Gtk::TreeModel::get_iter | ( | const Glib::ustring& | path_string | ) |

iterator Gtk::TreeModel::get_iter | ( | const Path& | path | ) |

virtual bool Gtk::TreeModel::get_iter_vfunc | ( | GtkTreeIter* | iter,
|  | const TreeModel::Path& | path
| ) | `[protected, virtual]`

int Gtk::TreeModel::get_n_columns | ( |  | ) | const

Returns the number of columns supported by tree_model .

Returns:
  The number of columns.

virtual int Gtk::TreeModel::get_n_columns_vfunc | ( |  | ) | `[protected, virtual]`

TreeModel::Path Gtk::TreeModel::get_path | ( | const iterator& | iter | ) | const

Returns a Gtk::TreePath referenced by iter .

Parameters:

  iter | The Gtk::TreeIter.

Returns:
  A Gtk::TreePath.

virtual TreeModel::Path Gtk::TreeModel::get_path_vfunc | ( | const TreeModel::iterator& | iter | ) | `[protected, virtual]`

Glib::ustring Gtk::TreeModel::get_string | ( | const iterator& | iter | ) | const

Generates a string representation of the iter.

This string is a ':' separated list of numbers. For example, "4:10:0:3" would be an acceptable return value for this string.

Parameters:

  iter | An Gtk::TreeIter.

Returns:
  The string.

Since: 2.2.

virtual void Gtk::TreeModel::get_value_impl | ( | const iterator& | row,
|  | int | column,
|  | Glib::ValueBase& | value
| ) | const`[protected, virtual]`

virtual void Gtk::TreeModel::get_value_vfunc | ( | const TreeModel::iterator& | iter,
|  | int | column,
|  | GValue* | value
| ) | `[protected, virtual]`

const GtkTreeModel* Gtk::TreeModel::gobj | ( |  | ) | const`[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::Interface. Reimplemented in Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

GtkTreeModel* Gtk::TreeModel::gobj | ( |  | ) | `[inline]`

| Provides access to the underlying C GObject. Reimplemented from Glib::Interface. Reimplemented in Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

virtual bool Gtk::TreeModel::iter_children_vfunc | ( | GtkTreeIter* | iter,
|  | const GtkTreeIter* | parent
| ) | `[protected, virtual]`

virtual bool Gtk::TreeModel::iter_has_child_vfunc | ( | const GtkTreeIter* | iter | ) | `[protected, virtual]`

virtual int Gtk::TreeModel::iter_n_children_vfunc | ( | const GtkTreeIter* | iter | ) | `[protected, virtual]`

virtual bool Gtk::TreeModel::iter_next_vfunc | ( | GtkTreeIter* | iter | ) | `[protected, virtual]`

virtual bool Gtk::TreeModel::iter_nth_child_vfunc | ( | GtkTreeIter* | iter,
|  | const GtkTreeIter* | parent,
|  | int | n
| ) | `[protected, virtual]`

virtual bool Gtk::TreeModel::iter_parent_vfunc | ( | GtkTreeIter* | iter,
|  | const GtkTreeIter* | child
| ) | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_changed | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter
| ) | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_deleted | ( | const TreeModel::Path& | path | ) | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_has_child_toggled | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter
| ) | `[protected, virtual]`

virtual void Gtk::TreeModel::on_row_inserted | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter
| ) | `[protected, virtual]`

virtual void Gtk::TreeModel::on_rows_reordered | ( | const TreeModel::Path& | path,
|  | const TreeModel::iterator& | iter,
|  | int* | new_order
| ) | `[protected, virtual]`

virtual void Gtk::TreeModel::ref_node_vfunc | ( | GtkTreeIter* | iter | ) | `[protected, virtual]`

void Gtk::TreeModel::row_changed | ( | const Path& | path,
|  | const iterator& | iter
| ) |

Emits the "row_changed" signal on tree_model .

Parameters:

  path | A Gtk::TreePath pointing to the changed row.
  iter | A valid Gtk::TreeIter pointing to the changed row.

void Gtk::TreeModel::row_deleted | ( | const Path& | path | ) |

Emits the "row_deleted" signal on tree_model .

This should be called by models after a row has been removed. The location pointed to by path should be the location that the row previously was at. It may not be a valid location anymore.

Parameters:

  path | A Gtk::TreePath pointing to the previous location of the deleted row.

void Gtk::TreeModel::row_has_child_toggled | ( | const Path& | path,
|  | const iterator& | iter
| ) |

Emits the "row_has_child_toggled" signal on tree_model .

This should be called by models after the child state of a node changes.

Parameters:

  path | A Gtk::TreePath pointing to the changed row.
  iter | A valid Gtk::TreeIter pointing to the changed row.

void Gtk::TreeModel::row_inserted | ( | const Path& | path,
|  | const iterator& | iter
| ) |

Emits the "row_inserted" signal on tree_model.

Parameters:

  path | A Gtk::TreePath pointing to the inserted row.
  iter | A valid Gtk::TreeIter pointing to the inserted row.

void Gtk::TreeModel::rows_reordered | ( | const Path& | path,
|  | const iterator& | iter,
|  | int* | new_order
| ) |

Emits the "rows_reordered" signal on tree_model .

This should be called by models when their rows have been reordered.

Parameters:

  path | A Gtk::TreePath pointing to the tree node whose children have been reordered.
  iter | A valid Gtk::TreeIter pointing to the node whose children have been reordered.
  new_order | An array of integers containing the new indices of the children, i.e. the former child `n` is now at position new_order `[n]`.

virtual void Gtk::TreeModel::set_value_impl | ( | const iterator& | row,
|  | int | column,
|  | const Glib::ValueBase& | value
| ) | `[protected, virtual]`

| Reimplemented in Gtk::ListStore, Gtk::TreeModelSort, and Gtk::TreeStore.

Glib::SignalProxy2<void,const TreeModel::Path&,const TreeModel::iterator&> Gtk::TreeModel::signal_row_changed | ( |  | ) |

Prototype:
  `void row_changed(const TreeModel::Path& path, const TreeModel::iterator& iter)`

Glib::SignalProxy1<void,const TreeModel::Path&> Gtk::TreeModel::signal_row_deleted | ( |  | ) |

Prototype:
  `void row_deleted(const TreeModel::Path& path)`

Glib::SignalProxy2<void,const TreeModel::Path&,const TreeModel::iterator&> Gtk::TreeModel::signal_row_has_child_toggled | ( |  | ) |

Prototype:
  `void row_has_child_toggled(const TreeModel::Path& path, const TreeModel::iterator& iter)`

Glib::SignalProxy2<void,const TreeModel::Path&,const TreeModel::iterator&> Gtk::TreeModel::signal_row_inserted | ( |  | ) |

Prototype:
  `void row_inserted(const TreeModel::Path& path, const TreeModel::iterator& iter)`

Glib::SignalProxy3<void,const TreeModel::Path&,const TreeModel::iterator&,int*> Gtk::TreeModel::signal_rows_reordered | ( |  | ) |

Prototype:
  `void rows_reordered(const TreeModel::Path& path, const TreeModel::iterator& iter, int* new_order)`

virtual void Gtk::TreeModel::unref_node_vfunc | ( | GtkTreeIter* | iter | ) | `[protected, virtual]`

## Friends And Related Function Documentation

friend class Gtk::TreeModelSort`[friend]`

friend class Gtk::TreeRow`[friend]`

Glib::RefPtr<Gtk::TreeModel> wrap | ( | GtkTreeModel* | object,
|  | bool | take_copy = false
| ) | `[related]`

The documentation for this class was generated from the following file:

- treemodel.h